<div class="animated fadeIn">
  <div class="row">
    <div class="col-lg-12">
      <div class="card">
        <div class="card-header">
          <i class="fa fa-globe"></i>{{'ip.blacklist' | translate}}
          <span class="float-right">
            <button (click)="add()" [disabled]="isEditing"
                    class="btn btn-block btn-primary">{{'common.add' | translate}}</button></span>
        </div>
        <div class="card-body" *ngIf="blacklists">
          <div class="row justify-content-between mb-2">
            <div class="col-6">
              <span class="float-left pr-3 show-entity-per-page-label">{{'common.show' | translate}}</span>
              <select (change)="onSearch()" [(ngModel)]="paging.limit" class="form-control float-left"
                      style="max-width: 70px" [disabled]="isEditing">
                <option *ngFor="let i of pagingNumbers" value="{{i.value}}">{{i.label}}</option>
              </select>
            </div>
            <div class="col-2">
              <div class="input-group float-right">
                <input type="text" [(ngModel)]="keywordSearch" class="form-control"
                       placeholder="{{'common.search' | translate}}">
                <div class="input-group-append">
                  <button (click)="onSearch()" class="btn btn-dark" type="button" [disabled]="isEditing">
                    <i class="fa fa-search"></i>
                  </button>
                </div>
              </div>
            </div>
          </div>
          <form [formGroup]="blacklistFormGroup">
            <table class="table table-bordered table-sort-icon">
              <thead>
              <tr appSort [disabled]="isEditing" [(orderBy)]="order.orderBy" [(orderType)]="order.orderType"
                  (orderChange)="changeOder($event)">
                <th class="text-center">
                  {{'ip.no' | translate}}</th>
                <th appSortBy="ip" class="text-center">
                  {{'ip.ip' | translate}}
                  <fa-icon></fa-icon>
                </th>
                <th class="text-center">{{'ip.netmask' | translate}}</th>
                <th class="text-center" appSortBy="description">
                  {{'ip.description' | translate}}
                  <fa-icon></fa-icon>
                </th>
                <th class="text-center">{{'ip.action' | translate}}</th>
              </tr>
              </thead>
              <tbody formArrayName="data" *ngFor="let ip of getFormData.controls; let i=index">
              <tr [formGroupName]="i">
                <td style="width: 4%" class="text-center"> {{i + 1 + paging.offset}}</td>
                <td style="width: 20%">
                  <span class="float-right" *ngIf="!ip.get('is_update').value">
                    {{ip.get('ip_address').value}}
                  </span>
                  <div *ngIf="ip.get('is_update').value">
                    <input type="text" class="form-control" formControlName="ip_address"
                           placeholder="{{'ip.ip_placeholder' | translate}}"
                           pattern="^((^\s*((([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5])\.){3}([0-9]|[1-9][0-9]|1[0-9]{2}|2[0-4][0-9]|25[0-5]))\s*$)|(^\s*((([0-9A-Fa-f]{1,4}:){7}([0-9A-Fa-f]{1,4}|:))|(([0-9A-Fa-f]{1,4}:){6}(:[0-9A-Fa-f]{1,4}|((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){5}(((:[0-9A-Fa-f]{1,4}){1,2})|:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3})|:))|(([0-9A-Fa-f]{1,4}:){4}(((:[0-9A-Fa-f]{1,4}){1,3})|((:[0-9A-Fa-f]{1,4})?:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){3}(((:[0-9A-Fa-f]{1,4}){1,4})|((:[0-9A-Fa-f]{1,4}){0,2}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){2}(((:[0-9A-Fa-f]{1,4}){1,5})|((:[0-9A-Fa-f]{1,4}){0,3}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(([0-9A-Fa-f]{1,4}:){1}(((:[0-9A-Fa-f]{1,4}){1,6})|((:[0-9A-Fa-f]{1,4}){0,4}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:))|(:(((:[0-9A-Fa-f]{1,4}){1,7})|((:[0-9A-Fa-f]{1,4}){0,5}:((25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)(\.(25[0-5]|2[0-4]\d|1\d\d|[1-9]?\d)){3}))|:)))(%.+)?\s*$))$">
                    <div class="text-danger"
                         *ngIf="ip.get('ip_address').touched || ip.get('ip_address').dirty && ip.get('ip_address').invalid">
                      <span class="form-text text-danger"
                            *ngIf="ip.get('ip_address').errors?.required">
                        {{'error.validate.input_required' | translate}}
                      </span>
                      <span class="form-text text-danger"
                            *ngIf="ip.get('ip_address').errors?.pattern ">
                        {{'error.validate.ipPattern' | translate}}
                      </span>
                    </div>
                  </div>
                </td>
                <td style="width: 20%">
                  <span class="float-right" *ngIf="!ip.get('is_update').value">
                    {{ip.get('netmask').value}}
                  </span>
                  <div *ngIf="ip.get('is_update').value">
                    <input type="text" class="form-control" formControlName="netmask"
                           placeholder="{{'ip.netmask_placeholder' | translate}}"
                           pattern="^(((255\.){3}(255|254|252|248|240|224|192|128|0+))|((255\.){2}(255|254|252|248|240|224|192|128|0+)\.0)|((255\.)(255|254|252|248|240|224|192|128|0+)(\.0+){2})|((255|254|252|248|240|224|192|128|0+)(\.0+){3}))$">
                    <div class="text-danger"
                         *ngIf="ip.get('netmask').touched || ip.get('netmask').dirty && ip.get('netmask').invalid">
                      <span class="form-text text-danger"
                            *ngIf="ip.get('netmask').errors?.required">
                        {{'error.validate.input_required' | translate}}
                      </span>
                      <span class="form-text text-danger"
                            *ngIf="ip.get('netmask').errors?.pattern ">
                        {{'error.validate.netmask' | translate}}
                      </span>
                    </div>
                  </div>
                </td>
                <td class="text-left">
                  <span *ngIf="!ip.get('is_update').value">
                    {{ip.get('description').value}}
                  </span>
                  <div *ngIf="ip.get('is_update').value">
                    <input type="text" class="form-control" formControlName="description"
                           placeholder="{{'ip.description_placeholder' | translate}}">
                    <span class="text-danger"
                          *ngIf="ip.get('description').touched && ip.get('description').invalid">{{'error.validate.input_required' | translate}}</span>
                    <span class="text-danger"
                          *ngIf="ip.get('description').touched && ip.get('description').errors?.maxlength">{{'error.validate.maxlength' | translate}}</span>
                  </div>
                </td>
                <td class="text-center">
                  <div class="btn-group">
                    <button *ngIf="!ip.get('is_update').value" (click)="onEdit(i)" [disabled]="isEditing"
                            type="submit"
                            class="btn btn-success btn-sm">
                      <i class="icon-pencil"></i>
                      <span class="d-none d-md-inline">{{'common.edit' | translate}}</span>
                    </button>
                    <button *ngIf="ip.get('is_update').value" (click)="save(i)" type="submit"
                            [disabled]="ip.invalid"
                            class="btn btn-primary btn-sm">
                      <i class="fa fa-save"></i>
                      <span class="d-none d-md-inline">{{'common.save' | translate}}</span>
                    </button>
                    <button *ngIf="!ip.get('is_update').value" type="submit" (click)="remove(deleteModal, i)"
                            [disabled]="isEditing" class="btn btn-danger btn-sm">
                      <i class="icon-action-undo"></i>
                      <span class="d-none d-md-inline">{{'common.delete' | translate}}</span>
                    </button>
                    <button *ngIf="ip.get('is_update').value" type="submit" (click)="onCancelEdit(i)"
                            class="btn btn-danger btn-sm">
                      <i class="icon-action-undo"></i>
                      <span class="d-none d-md-inline">{{'common.cancel' | translate}}</span>
                    </button>
                  </div>
                </td>
              </tr>
              </tbody>
            </table>
          </form>
          <div class="row justify-content-between" *ngIf="blacklists.length > 0">
            <span class="col-6">{{'common.pagingInfo' | translate : {
              start: paging.offset + 1,
              end: (paging.offset + getFormData.controls.length),
              total: paging.total
            } }}</span>

            <div class="col-6">
              <ngb-pagination class="float-right" [boundaryLinks]="true" [collectionSize]="paging.total"
                              [pageSize]="paging.limit" [maxSize]="5" [rotate]="true" [(page)]="paging.page"
                              (pageChange)="loadPage(paging.page)">
              </ngb-pagination>
            </div>
          </div>
          <div *ngIf="!blacklists || blacklists.length === 0" class="text-center">
            <span>{{'common.no_record' | translate}}</span>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>
<ng-template #deleteModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-delete-title">{{'ip.delete_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'ip.delete_popup.message' | translate: {name: selectedIp.ip_address} }}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger"
            (click)="modal.close('delete')">{{'common.delete' | translate}}</button>
    <button type="button" class="btn btn-secondary"
            (click)="modal.close('Close')">{{'common.close' | translate}}</button>
  </div>
</ng-template>

<ng-template #saveModal let-modal>
  <div class="modal-header">
    <h4 class="modal-title" id="modal-comfirm-save-title">{{'ip.save_popup.title' | translate}}</h4>
    <button type="button" class="close" aria-label="Close" (click)="modal.dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    {{'ip.save_popup.message' | translate: {name: selectedIp.ip_address} }}
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-danger" (click)="modal.close('save')">{{'common.save' | translate}}</button>
    <button type="button" class="btn btn-secondary"
            (click)="modal.close('Close')">{{'common.close' | translate}}</button>
  </div>
</ng-template>

